import React,{ useEffect, useState } from 'react';
import {  Card, Form, Input, Button, Select, Table, Tag, Space, notification  } from 'antd';
import { PageContainer } from '@ant-design/pro-layout';
import { connect } from 'react-redux';
import { get, post } from 'services';

const { Option } = Select
const formLables = {
    ip:'服务器名或IP地址',
    userName:'数据库用户名称',
    password:'数据库用户密码',
    dbName:'数据库名称',
}
const InitDataBase = (props) =>{
    const [form] = Form.useForm()
    const onFinish = (e) =>{
    }
    const [tableLoading, setTableLoading] = useState(false)
    const [dbForm,setDbForm] = useState({
        ip:'',
        dbName:'',
        password:'',
        userName:'',
        inUse:'',
    })
    const [data, setData ] = useState([]) //数据库链接记录
    const [option, setOption] =useState([]) //下拉列表数据
    console.log(window.location.host)
    //获取数据库链接记录
    useEffect( () =>{
        setTableLoading(true)
        get(`/Cityinterface/rest/services/OMS.svc/S_GetConnRecord`,{
            _version:9999,
            dc:1603334559186
        }).then(res =>{
            setTableLoading(false)
            if(res.length>0){ 
                let arr = res.map( (item,index) =>{
                    item.key = index
                    return item
                })      
                setData(arr)
            }
        }).catch(err =>{
            setTableLoading(false)
            console.error(err)
        })
    },[])
    //获取数据库配置信息
    useEffect( () =>{
        get(`/Cityinterface/rest/services/OMS.svc/S_GetDataBaseConfig`,{
            _version:9999,
            dc:1603334559186
        }).then(res =>{
            console.log(res)
            if(res.success){               
            let obj ={}
            for( let k in dbForm){
                obj[k]=res[k]
            }
            form.setFieldsValue(obj)
            setDbForm((val)=>{
                return {...val,...obj}
            })
            }
        }).catch(err =>{
            console.error(err)
        })
    },[])
    const testChlick = () =>{
    }
    const onValuesChange =(value,b)=>{
        form.setFieldsValue(value)
    }
    const onChange = (value) => {
        form.setFieldsValue({
            dbName:value
        })
    }
    const onCheck = (e) =>{
        console.log(dbForm)
        console.log(form.getFieldValue())
        console.log(form.getFieldsValue())
       
    }
    const selectFocus = (e) =>{
        setOption([])
        let params =form.getFieldsValue()
        get(`/Cityinterface/rest/services/OMS.svc/S_GetDataBaseList`,{
            _version:9999,
            _dc:1603334559186,
            userName:params['userName']||'',
            password:params['password']||'',
            ip:params['ip']||'',
        }).then(res =>{
            if(res.success){
                setOption(res.root)
            }else{
                notification.error({
                    message:'通知',
                    duration:3,
                    description:res.message
                })
                setOption([])
            }
            console.log(res)
        }).catch(err =>{
            console.error(err)
        })

    }
    //点击表格回显到表单
    const tableClick = (item) => {
       let obj =  {...dbForm}
       for(let k in obj){
        obj[k] = item[k]
       }
       form.setFieldsValue(obj)
    }
    const columns = [
        {
            title: '服务器名或IP地址',
            dataIndex: 'ip',
            key: 'ip',
        },
        {
            title: '数据库名称',
            dataIndex: 'dbName',
            key: 'dbName',
        },
        {
            title: '数据库用户名称',
            dataIndex: 'userName',
            key: 'userName',
        },
        {
            title: '保存时间',
            dataIndex: 'saveTime',
            key: 'saveTime',
        },
        {
            title: '描述',
            dataIndex: 'desc',
            key: 'desc',
        },
        {
            title: '修改描述',
            dataIndex: 'name',
            key: 'name',
            render: () =>{
                return (
                    <button>修改描述</button>
                )
            }
        },
        {
            title: '删除',
            dataIndex: 'name',
            key: 'name',
            render: () =>{
                return (
                    <button>删除</button>
                )
            }
        },
    ]
    return (
        <>
            <PageContainer>
                <Card>
                    <div>数据库初始化</div>
                    <div></div>
                    <Form
                        layout="horizontal"
                        labelAlign='left'
                        labelCol={{span:3}}
                        form={form}
                        onFinish={onFinish}
                        onValuesChange= {onValuesChange}
                    >
                        <Form.Item label={`${formLables.ip}:`} name='ip'>
                            <Input placeholder="请输入" />
                        </Form.Item>
                        <Form.Item label={`${formLables.userName}:`} name='userName'>
                            <Input placeholder="请输入" />
                        </Form.Item>
                        <Form.Item label={`${formLables.password}:`} name = 'password'>
                            <Input placeholder="请输入" />
                        </Form.Item>
                        <Form.Item label={`${formLables.dbName}:`} name = 'dbName'>
                            <Select
                                showSearch
                                placeholder="请选择"
                                optionFilterProp="children"
                                onFocus = {()=>{selectFocus()}}
                                onChange={(e) =>{onChange(e)}}
                                filterOption={(input, option) =>
                                option.children.toLowerCase().indexOf(input.toLowerCase()) >= 0
                                }
                            >
                                {option && option.length>0 &&option.map( (item, index) =>{
                                    return (<Option value={item.value} key={index}>{item.value}</Option>)
                                })}
                            </Select>
                        </Form.Item>
                        <Form.Item >
                            <Space size='large'>
                            <Button onClick={onCheck}>测试连接</Button>
                            <Button htmlType='submit'>保存连接</Button>
                            <Button htmlType='reset' onClick = { testChlick}>数据库初始化</Button>
                            </Space>
                            <span>{dbForm.inUse}</span>
                        </Form.Item>
                        {/* <div className={`btnBox`}>
                            <Button onClick={onCheck}>测试连接</Button>
                            <Button>保存连接</Button>
                            <Button>数据库初始化</Button>
                            <span>(产品方案(物联GCK))</span>
                        </div> */}
                    </Form>
                </Card>
                
                <Card>
                    <div>近期保存的数据库连接</div>
                    <Table columns={columns} dataSource={data} bordered loading={tableLoading}
                    onRow={record => {
                        return {
                          onClick: () => { tableClick(record)}, // 点击行
                        };
                      }}
                    />
                </Card>
            </PageContainer>
        </>
    )
}

export default connect()(InitDataBase);
